; LINKTEST.ASM - Program to read link port status.
; By Andrew Tipton - Feel free to use this in any way you please
;		     EXCEPT commercial use. :)

#include "ti82.h"

.org 0

	ROM_CALL(CLEARLCD)	;Clear LCD
	ld hl, (PROGRAM_ADDR)	;Load hl w/ start of prgm
	ld de, MainScrn		;Load in address in prgm of the main screen
	add hl,de		;Get absolute address of MainScrn
	ld bc,$0000		;Load $0000 into register bc
	ld ($800C),bc		;Load register bc into Row,Col RAM location
	ROM_CALL(D_ZT_STR)	;Display string at location hl
LinkLoop:
	in a,(0)		;Read port 0
				;Bit 0(Red) & Bit 1(White) are 0=off, 1=on
	ld bc,$0C02		;Display at Row $02, Col $0C	
	ld ($800C),bc		
	bit 0,a
	jr nz,DisplayR0
	ld a,$31
	jr TestBit1
DisplayR0:
	ld a,$30
TestBit1:
	ROM_CALL(TR_CHARPUT)	;Put character on display
	ld bc,$0C03		;Display at Row $03, Col $0C	
	ld ($800C),bc		
	in a,(0)
	bit 1,a
	jr nz,DisplayW0
	ld a,$31
	jr KeyLoop
DisplayW0:
	ld a,$30
KeyLoop:
	ROM_CALL(TR_CHARPUT)	;Put character on display
	call GET_KEY		;Get a key from buffer
	cp $37			;Is it Quit?
	ret z			;If so, return
	jr LinkLoop		;Otherwise, check linkport status again

MainScrn:
	.db "--- LinkTest ---"
	.db "                "
	.db "  Red Wire:     "
	.db "White Wire:     "
	.db "                "
	.db "                "
	.db "By Andrew Tipton"
	.db "(c) 1997       ",0	
	.end
